
// CombiDlg.cpp : implementation file
//-----------------------------------
#include "stdafx.h"
#include "Combi.h"
#include "CombiDlg.h"
#include "MDBEngine.h"
#include "DiagnosticDlg.h"
#include "DebugDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CAboutDlg dialog used for App About
//------------------------------------

class CAboutDlg : public CDialog
//==============================
{
public:
	CAboutDlg();
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX); // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
//==============================================
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
//================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CCombiDlg dialog
//-----------------

CCombiDlg::CCombiDlg(CWnd* pParent)	: CDialog(CCombiDlg::IDD, pParent)
//====================================================================
{
	//{{AFX_DATA_INIT(CCombiDlg)
	m_dwCredit = 0;
	m_dwTransaction = 0;
	m_DebugTrace = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon=AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_dwCoinCount=0;
}

void CCombiDlg::DoDataExchange(CDataExchange* pDX)
//================================================
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCombiDlg)
	DDX_Control(pDX, IDC_LAST_STATUS, m_LastStatus);
	DDX_Text(pDX, IDC_CREDIT, m_dwCredit);
	DDX_Text(pDX, IDC_TRANSACTION, m_dwTransaction);
	DDX_Check(pDX, IDC_DEBUG_TRACE, m_DebugTrace);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCombiDlg, CDialog)
	//{{AFX_MSG_MAP(CCombiDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_ABOUTBOX, OnAboutbox)
	ON_BN_CLICKED(IDC_PLUS, OnPlus)
	ON_BN_CLICKED(IDC_MINUS, OnMinus)
	ON_BN_CLICKED(IDC_PAYOUT, OnPayout)
	ON_BN_CLICKED(IDC_ENABLE, OnEnable)
	ON_BN_CLICKED(IDC_DISABLE, OnDisable)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_BILL_ACCEPT, OnBillAccept)
	ON_BN_CLICKED(IDC_BILL_ESCROW, OnBillEscrow)
	ON_BN_CLICKED(IDC_BILL_ENABLE, OnBillEnable)
	ON_BN_CLICKED(IDC_BILL_DISABLE, OnBillDisable)
	ON_BN_CLICKED(IDC_BILL_RESET, OnBillReset)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_DIAGNOSTICS, OnDiagnostics)
	ON_COMMAND(IDM_DEBUG, OnDebug)
	ON_BN_CLICKED(IDC_DEBUG_TRACE, OnDebugTrace)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_ACCEPTOR_STATUS, OnStatusChanged)
	ON_MESSAGE(WM_BILL_STATUS, OnBillStatus)
END_MESSAGE_MAP()

// CCombiDlg message handlers
//---------------------------

BOOL CCombiDlg::OnInitDialog()
//============================
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog. The framework does this automatically
	// when the application's main window is not a dialog
	//--------------------------------------------------------------------
	SetIcon(m_hIcon,TRUE); // Set big icon
	SetIcon(m_hIcon,FALSE);	// Set small icon

	// Initialize change giver
	//------------------------
	SLAVE_SETUP Setup;
	memset(&Setup,0,sizeof(SLAVE_SETUP));
	Setup.lParam=(LPARAM)this;
	Setup.hParent=m_hWnd;
	Setup.dwDevice=0;
	Setup.dwInterval=100;
	Setup.dwTimeout=10;
	Setup.dwMaxRetry=10;
	Setup.dwMaxFail=10;
	if (!AcceptorCreate(&Setup))
	{
		TRACE(_T("Failed to create changer\r\n"));
	}

	// Initialize bill acceptor
	//-------------------------
	memset(&m_BillInfo,0,sizeof(BILL_INFO));
	memset(&Setup,0,sizeof(SLAVE_SETUP));
	Setup.lParam=(LPARAM)this;
	Setup.hParent=m_hWnd;
	Setup.dwDevice=0;
	Setup.dwTimeout=10;
	Setup.dwInterval=100;
	Setup.dwMaxRetry=10;
	Setup.dwMaxFail=10;
	if (!BillCreate(&Setup))
	{
		TRACE(_T("Failed to create bill acceptor\r\n"));
	}
	return true;
}

void CCombiDlg::OnDestroy() 
//=========================
{
	AcceptorDestroy();
	BillDestroy();
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon. For MFC applications using the document/view model,
// this is automatically done for you by the framework.
//--------------------------------------------------------------------------

void CCombiDlg::OnPaint() 
//=======================
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND,(WPARAM) dc.GetSafeHdc(),0);

		// Center icon in client rectangle
		//--------------------------------
		int cxIcon=GetSystemMetrics(SM_CXICON);
		int cyIcon=GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x=(rect.Width()-cxIcon+1)/2;
		int y=(rect.Height()-cyIcon+1)/2;

		// Draw the icon
		//--------------
		dc.DrawIcon(x,y,m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display
// while the user drags the minimized window.
//------------------------------------------------------

HCURSOR CCombiDlg::OnQueryDragIcon()
//==================================
{
	return (HCURSOR)m_hIcon;
}

void CCombiDlg::OnAboutbox() 
//==========================
{
	CAboutDlg AboutDlg;
	AboutDlg.DoModal();
}

void CCombiDlg::OnStatusChanged(WPARAM wParam, LPARAM lParam)
//===========================================================
{
	TRACE(_T("Changer status changed: %u\r\n"),wParam);
	switch (wParam)
	{
		case SS_ACCEPTOR_READY:
		{
			ACCEPTOR_INFO Info;
			if (AcceptorInfo(&Info))
			{
				UpdateData(true);
			}
			break;
		}
		case SS_ACCEPTOR_FUNDS:
		{
			AcceptorFunds(&m_dwCredit);
			UpdateData(false);
			m_dwCoinCount++;
			TRACE(_T("Coin count: %d\r\n"),m_dwCoinCount);
			break;
		}
		case SS_ACCEPTOR_ESCROW:
		{
			OnPayout();
			break;
		}
		case SS_ACCEPTOR_RESET:
		{
			break;
		}
		case SS_ACCEPTOR_ERROR:
		{
			break;
		}
		default:
		{
			;
		}
	}
}

void CCombiDlg::OnPlus() 
//======================
{
	UpdateData(true);
	if (m_dwTransaction)
	{
		AcceptorRefund(m_dwTransaction);
	}
}

void CCombiDlg::OnMinus() 
//=======================
{
	UpdateData(true);
	if (m_dwTransaction)
	{
		AcceptorDeduct(m_dwTransaction);
	}
}

void CCombiDlg::OnPayout() 
//========================
{
	AcceptorPayout();
}

void CCombiDlg::OnEnable() 
//========================
{
	ACCEPTOR_ENABLE Enable;
	Enable.dwAccepting=0x0000FFFF;
	Enable.dwManually=0x0000FFFF;
	AcceptorEnable(&Enable);
}

void CCombiDlg::OnDisable() 
//=========================
{
	ACCEPTOR_ENABLE Enable;
	Enable.dwAccepting=0;
	Enable.dwManually=0;
	AcceptorEnable(&Enable);
}

void CCombiDlg::OnReset() 
//=======================
{
	AcceptorReset();	
}


void CCombiDlg::OnBillStatus(WPARAM wParam, LPARAM lParam)
//========================================================
{
	TRACE(_T("Bill acceptor status changed: %d\r\n"),wParam);
	switch (wParam)
	{
		case SS_BILL_READY:
		{
			if (!BillInfo(&m_BillInfo))
				break;
			m_LastStatus.SetWindowText(_T("Ready."));
			break;
		}
		case SS_BILL_STATUS:
		{
			BILL_STATUS Status;
			if (!BillStatus(&Status))
				break;
			switch (Status.dwBillStatus)
			{
				case 0x06:
				{
					m_LastStatus.SetWindowText(_T("Just reset."));
					break;
				}
				case 0x08:
				{
					m_LastStatus.SetWindowText(_T("Cashbox out of position."));
					break;
				}
				case 0x09:
				{
					m_LastStatus.SetWindowText(_T("Unit disabled."));
					break;
				}
				case 0x0A:
				{
					m_LastStatus.SetWindowText(_T("Invalid escrow request."));
					break;
				}
				case 0x0B:
				{
					m_LastStatus.SetWindowText(_T("Bill rejected."));
					break;
				}
			}
			break;
		}
		case SS_BILL_ESCROW:
		{
			m_LastStatus.SetWindowText(_T("Bill in escrow position."));
			break;
		}
		case SS_BILL_STACKED:
		{
			BILL_STATUS Status;
			if (!BillStatus(&Status))
				break;
			m_dwCredit+=m_BillInfo.dwBillScalingFactor*m_BillInfo.BillTypeCredit[Status.dwBillType];
			UpdateData(false);
			m_LastStatus.SetWindowText(_T("Bill stacked."));
			break;
		}
		case SS_BILL_RETURNED:
		{
			m_LastStatus.SetWindowText(_T("Bill returned."));
			break;
		}
	}
}

void CCombiDlg::OnBillAccept() 
//============================
{
	BillEscrow(true);	
}

void CCombiDlg::OnBillEscrow() 
//============================
{
	BillEscrow(false);		
}

void CCombiDlg::OnBillEnable() 
//============================
{
	BillEnable(0x0000000F,0x0000000F);
	m_LastStatus.SetWindowText(_T("Unit enabled."));
}

void CCombiDlg::OnBillDisable() 
//=============================
{
	BillEnable(0,0);	
	m_LastStatus.SetWindowText(_T("Unit disabled."));
}

void CCombiDlg::OnBillReset() 
//===========================
{
	BillReset();	
}

void CCombiDlg::OnDiagnostics() 
//=============================
{
	CDiagnosticDlg DiagDlg;
	DiagDlg.DoModal();	
}

void CCombiDlg::OnDebug() 
//=======================
{
	CDebugDlg DebugDlg;
	DebugDlg.DoModal();
}

void CCombiDlg::OnDebugTrace() 
//============================
{
	UpdateData(true);
	if (m_DebugTrace)
	{
		DebugCreate();
		DebugSetTrace(DBG_MASTER_TRACE,1);
	}
	else
	{
		DebugSetTrace(DBG_ALL_OFF,0);
		DebugDestroy();
	}
}
